/*

  OSD click driver

*/
sbit OSD_CS at LATE.B0;
sbit OSD_CS_Direction at TRISE.B0;

void MAX7456_SPI_WRITE(unsigned short ADDRESS, unsigned short DATA){
  OSD_CS = 0;                // Selecting the OSD click
  Delay_1us();               //
  SPI1_Write(ADDRESS);       // Send the ADDRESS of registe in which you wish to wite DATA
  SPI1_Write(DATA);          // Send the DATA which you wish to wite
  Delay_1us();               //
  OSD_CS = 1;                // Deselecting the OSD click
  Delay_us(10);
}
unsigned short MAX7456_SPI_READ(unsigned short ADDRESS){
unsigned short temp;
  OSD_CS = 0;                // Selecting the OSD click
  Delay_1us();               //
  SPI1_Write(ADDRESS);       // Send the ADDRESS of registe from which you wish to read DATA
  Delay_1us();               //
  temp  = SPI1_Read(0);      // Read the register DATA
  OSD_CS = 1;                // Deselecting the OSD click
  Delay_us(20);
}

void MAX7456_init(){
unsigned short temp;
  MAX7456_SPI_WRITE(0x00, 0x4C);   // Setup Video Mode 0 register
  temp  = MAX7456_SPI_READ(0xEC);  // Read OSD Black Level register
  temp&= 0xEF;
  MAX7456_SPI_WRITE(0x6C, temp);  // Setup OSD Black Level register
  MAX7456_SPI_WRITE(0x04, 0x04);  // Setup Display Memory Mode register
  MAX7456_SPI_WRITE(0x02, 0x26);  // Horizotal offset for ~1/2 of character
}

void MAX7456_Write(unsigned short x, unsigned short y, unsigned short symbol)
  {
  OSD_CS = 0;                     // Selecting the OSD click
  Delay_1us();                    //
  SPI1_Write(0x05);               // Address to Display Memory Address High
  if( ( x * 30 + y ) <= 255 )
    SPI1_Write(0);                // For first 255 matrix positions Write 0
  else
    SPI1_Write(1);                // For the rest of matrix positions Write 1
  Delay_1us();
  OSD_CS = 1;                     // Deselecting the OSD click
  Delay_us(10);

  MAX7456_SPI_WRITE(0x06, x * 30 + y );  // Set position in display matrix(16x30)
  MAX7456_SPI_WRITE(0x07, symbol);       // Set character on selected position
}

void MAX7456_InsertCustomChar(unsigned short chrAddrress, const char CChar[]){
unsigned short temp;
unsigned short i;
  // Disable OSD
  temp = MAX7456_SPI_READ(0x00);
  temp &= 0xF7;
  MAX7456_SPI_WRITE(0x00, temp);

  MAX7456_SPI_WRITE(0x09, chrAddrress);
  for(i = 0; i < 53; i++){
     MAX7456_SPI_WRITE(0x0A, i);
     MAX7456_SPI_WRITE(0x0B, CChar[i]);
  }
  MAX7456_SPI_WRITE(0x08, 0xA0);
  while(1){
    temp = MAX7456_SPI_READ(0xA0);
    temp &= 0b00100000;
    if (!temp)
      break;
  }
  // Enable OSD
  temp  = MAX7456_SPI_READ(0x00);
  temp|= 0x08;
  MAX7456_SPI_WRITE(0x00, temp);
}