/*

  OSD MENU Driver Functions

*/
#define BTN_DELAY 40
#define RTC_ADDR  0xD0
// EXTERN
const char OSDchr[256]; extern;
const char OSmenu[8][20]; extern;
void MAX7456_Write(unsigned short positionH, unsigned short positionL, unsigned short symbol); extern;
void MAX7456_SPI_WRITE(unsigned short ADDRESS, unsigned short DATA); extern;

// LOCAL GLOBALS
unsigned short volume = 15;   // Keeps the of set volume
unsigned short btn = 0;       // Gives the message of pressed button
unsigned short inv_flag = 0;  // Color of OSD - White&Black or Blac&White
unsigned short oldstate = 0;  // Button press - release hellper

/* Flag variables which make display menu work */
unsigned short MenuState = 0;
unsigned short SelectedOption = 1;
unsigned short timeOption = 0;
unsigned short dateOption = 0;

/* Counter and flag variable for blink effect */
unsigned short blinkC;
unsigned short blinkF;

unsigned char shour=0, smin=0, sday=0, smonth=0, syear=0;

unsigned short PressReleaseCheck(){
  //-------------RD0
  if (Button(&PORTD, 0, 1, 1))                         // Detect logical one
     oldstate = 1;                                     // Update flag
   if ((oldstate == 1) && Button(&PORTD, 0, 1, 0)) {   // Detect one-to-zero transition
     oldstate = 0;
     return 1;
   }
   //------------RD1
   if (Button(&PORTD, 1, 1, 1))                        // Detect logical one
     oldstate = 2;                                     // Update flag
   if ((oldstate == 2) && Button(&PORTD, 1, 1, 0)) {   // Detect one-to-zero transition
     oldstate = 0;
     return 2;
   }
   //------------RD2
   if (Button(&PORTD, 2, 1, 1))                        // Detect logical one
     oldstate = 3;                                     // Update flag
   if ((oldstate == 3) && Button(&PORTD, 2, 1, 0)) {   // Detect one-to-zero transition
     oldstate = 0;
     return 3;
   }
   //------------RD3
   if (Button(&PORTD, 3, 1, 1))                        // Detect logical one
     oldstate = 4;                                     // Update flag
   if ((oldstate == 4) && Button(&PORTD, 3, 1, 0)) {   // Detect one-to-zero transition
     oldstate = 0;
      return 4;
   }
   //-------------No button is pressed
   return 0;
}
/* Required for continues volume control */
unsigned short PressHoldCheck(){
  //-------------RD0
  if (Button(&PORTD, 0, BTN_DELAY, 1))    // Detect zero-to-one transition
    return 1;
  //-------------RD1
  if (Button(&PORTD, 1, BTN_DELAY, 1))    // Detect zero-to-one transition
    return 2;
  //-------------RD2
  if (Button(&PORTD, 2, BTN_DELAY, 1))    // Detect zero-to-one transition
    return 3;
  //-------------RD3
  if (Button(&PORTD, 3, BTN_DELAY, 1))    // Detect zero-to-one transition
    return 4;
  return 0;
}

/* Clears the char places from xStart row up to xEnd row and from yStart column to yEnd column */
/* Tto clear the complete display xStart = 0, xEnd = 16, yStart = 0, yEnd = 30 */
void ClearOSD(unsigned short xStart, unsigned short yStart, unsigned short xEnd, unsigned short yEnd){
short i, j;
  for (i = xStart; i < xEnd; i++ ){
    for (j = yStart; j < yEnd; j++ ){
        MAX7456_Write(i, j, 0);
    }
  }
}

void SetupTimeOnOSD(){         // Writes the configuration time on display
  MAX7456_Write(6, 12, OSDchr[(shour / 10)   + 48]);
  MAX7456_Write(6, 13, OSDchr[(shour % 10)   + 48]);
  MAX7456_Write(6, 14, OSDchr[':']);
  MAX7456_Write(6, 15, OSDchr[(smin / 10) + 48]);
  MAX7456_Write(6, 16, OSDchr[(smin % 10) + 48]);
}

void SetupDateOnOSD(){         // Writes the configuration date on display
  MAX7456_Write(6, 8, OSDchr[(sday / 10)   + 48]);
  MAX7456_Write(6, 9, OSDchr[(sday % 10)   + 48]);
  MAX7456_Write(6, 10, OSDchr['.']);
  MAX7456_Write(6, 11, OSDchr[(smonth / 10) + 48]);
  MAX7456_Write(6, 12, OSDchr[(smonth % 10) + 48]);
  MAX7456_Write(6, 13, OSDchr['.']);
  MAX7456_Write(6, 14, OSDchr['2']);
  MAX7456_Write(6, 15, OSDchr['0']);
  MAX7456_Write(6, 16, OSDchr[(syear / 10) + 48]);
  MAX7456_Write(6, 17, OSDchr[(syear % 10) + 48]);
  MAX7456_Write(6, 18, OSDchr['.']);
}

void UpdateMenu(signed short val){
  if (val < 0){
    if(selectedOption > 1){
      selectedOption--;                                   // Upadate selected option
      MAX7456_Write(5 + selectedOption, 7, OSDchr[' ']);  // Remove the '>' from last selected option
      MAX7456_Write(4 + selectedOption, 7, OSDchr['>']);  // Set the '>' to new selected option
    }
  }
  if (val > 0){
    if(selectedOption < 4){
      selectedOption++;                                   // Upadate selected option
      MAX7456_Write(3 + selectedOption, 7, OSDchr[' ']);  // Remove the '>' from last selected option
      MAX7456_Write(4 + selectedOption, 7, OSDchr['>']);  // Set the '>' to new selected option
    }
  }
}
void UpdateRTC_Time(unsigned char c_hours, unsigned char c_minutes){
  unsigned char m;
  unsigned char h;
  /* Prepare minutes and hours values for RTC2 registers */
  m = (((c_minutes / 10) & 0x0F) << 4 ) + ((c_minutes % 10) & 0x0F);
  h = (((c_hours / 10) & 0x03) << 4 ) + ((c_hours % 10) & 0x0F);

  I2C1_Start();                     // issue start signal
  I2C1_Wr(RTC_ADDR);                // address DS1307
  I2C1_Wr(0);                       // start from word at address (REG0)
  I2C1_Wr(0x80);                    // write $80 to REG0. (pause counter + 0 sec)
  I2C1_Wr(m);                       // write minutes word to (REG1)
  I2C1_Wr(h);                       // write hours word (24-hours mode)(REG2)
  I2C1_Stop();                      // issue stop signal

  I2C1_Start();                     // issue start signal
  I2C1_Wr(RTC_ADDR);                // address DS1307
  I2C1_Wr(0);                       // start from word at address 0
  I2C1_Wr(0);                       // write 0 to REG0 (enable counting + 0 sec)
  I2C1_Stop();                      // issue stop signal
}

void UpdateTime(signed short val){
  unsigned short i;

  switch(timeOption){
  case 0:                           // SET UP HOURS
    if (val < 0){
      if(shour > 0){
        shour--;                    // Decrease hours
      }
      else{                         // On decrease overflow reset to max
        shour = 23;
      }
    }
    if (val > 0){
      if(shour < 23){
        shour++;                    // Increase hours
      }
      else{                         // On increase overflow reset to min
        shour = 0;
      }
    }
  break;
  case 1:                           // SET UP MINUTES
    SetupTimeOnOSD();
    /* Update dispaly instructions */
    MAX7456_Write(8, 10, OSDchr['S']);
    MAX7456_Write(8, 11, OSDchr['E']);
    MAX7456_Write(8, 12, OSDchr['T']);
    MAX7456_Write(8, 14, OSDchr['M']);
    MAX7456_Write(8, 15, OSDchr['I']);
    MAX7456_Write(8, 16, OSDchr['N']);
    MAX7456_Write(8, 17, OSDchr['U']);
    MAX7456_Write(8, 18, OSDchr['T']);
    MAX7456_Write(8, 19, OSDchr['E']);
    MAX7456_Write(8, 20, OSDchr['S']);
    if (val < 0){
      if(smin > 0){
        smin--;                     // Decrease minutes
      }
      else{                         // On decrease overflow reset to max
        smin = 59;
      }
    }
    if (val > 0){
      if(smin < 59){
        smin++;                     // Increase minutes
      }
      else{                         // On increase overflow reset to min
        smin = 0;
      }
    }
  break;
  case 2:                           // ASK FOR CONFIRMATION
    SetupTimeOnOSD();
    MAX7456_Write(6, 18, OSDchr['O']);
    MAX7456_Write(6, 19, OSDchr['K']);
    MAX7456_Write(6, 20, OSDchr['?']);
  break;
  case 3:                           // CONFIRMATION RECEIVED - Write the time to RTC2 registers.
    I2C1_Init(100000);              // I2C and SPI are on same MCU pins
    UpdateRTC_Time(shour, smin);    // Write the time to RTC2 registers
    Delay_us(5);                    // Small delay required after writing via I2C
    SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV4 , 
                       _SPI_DATA_SAMPLE_MIDDLE, 
                       _SPI_CLK_IDLE_LOW, 
                       _SPI_LOW_2_HIGH);
    ClearOSD(3,5,11,25);            // Hide Menu Dialog
    MenuState = 0;                  //
    SelectedOption = 1;             // Reset tacking variables
    timeOption = 0;                 //
  break;
  }
}

void UpdateRTC_Date(unsigned char c_day, unsigned char c_month, unsigned char c_year){
   unsigned char d, m ,y;
   d = (((c_day / 10) & 0x0F) << 4 ) + ((c_day % 10) & 0x0F);
   m = (((c_month / 10) & 0x01) << 4 ) + ((c_month % 10) & 0x0F);
   y = (((c_year / 10) & 0x0F) << 4 ) + ((c_year % 10) & 0x0F);
   I2C1_Start();                     // issue start signal
   I2C1_Wr(RTC_ADDR);                // address DS1307
   I2C1_Wr(3);                       // start from word at address (REG0+3)
   I2C1_Wr(0x80);                    // write $80 to REG0. (pause counter + 0 sec)

   I2C1_Wr(d);                       // write to date word (REG4)
   I2C1_Wr(m);                       // write to month word(REG5)
   I2C1_Wr(y);                       // write to year word (REG6)
   I2C1_Stop();                      // issue stop signal

   I2C1_Start();                     // issue start signal
   I2C1_Wr(RTC_ADDR);                // address DS1307
   I2C1_Wr(0);                       // start from word at address 0
   I2C1_Stop();                      // issue stop signal
}

void UpdateDate(signed short val){
  unsigned short i;

  switch(dateOption){
  case 0:
    if (val < 0){
      if(sday > 1){
        sday--;                      // Decrease day
      }
      else{                          // On decrease overflow reset to max
        sday = 31;
      }
    }
    if (val > 0){
      if(sday < 31){
        sday++;                      // Increase day
      }
      else{                          // On increase overflow reset to min
        sday = 1;
      }
    }
  break;
  case 1:
    SetupDateOnOSD();
    MAX7456_Write(8, 10, OSDchr['S']);
    MAX7456_Write(8, 11, OSDchr['E']);
    MAX7456_Write(8, 12, OSDchr['T']);
    MAX7456_Write(8, 14, OSDchr['M']);
    MAX7456_Write(8, 15, OSDchr['O']);
    MAX7456_Write(8, 16, OSDchr['N']);
    MAX7456_Write(8, 17, OSDchr['T']);
    MAX7456_Write(8, 18, OSDchr['H']);
    if (val < 0){
      if(smonth > 1){
        smonth--;                    // Decrease month
      }
      else{                          // On decrease overflow reset to max
        smonth = 12;
      }
    }
    if (val > 0){
      if(smonth < 12){
        smonth++;                    // Increase month
      }
      else{                          // On increase overflow reset to min
        smonth = 1;
      }
    }
  break;
  case 2:
    SetupDateOnOSD();
    MAX7456_Write(8, 10, OSDchr['S']);
    MAX7456_Write(8, 11, OSDchr['E']);
    MAX7456_Write(8, 12, OSDchr['T']);
    MAX7456_Write(8, 14, OSDchr['Y']);
    MAX7456_Write(8, 15, OSDchr['E']);
    MAX7456_Write(8, 16, OSDchr['A']);
    MAX7456_Write(8, 17, OSDchr['R']);
    MAX7456_Write(8, 18, OSDchr[' ']);
    if (val < 0){
      if(syear > 0){
        syear--;                     // Decrease year
      }
      else{                          // On decrease overflow reset to max
        syear = 99;
      }
    }
    if (val > 0){
      if(syear < 99){
        syear++;                     // Increase year
      }
      else{                          // On increase overflow reset to min
        syear = 0;
      }
    }
  break;
  case 3:                            // ASK FOR CONFIRMATION
    SetupDateOnOSD();
    MAX7456_Write(6, 20, OSDchr['O']);
    MAX7456_Write(6, 21, OSDchr['K']);
    MAX7456_Write(6, 22, OSDchr['?']);
  break;
  case 4:                           // CONFIRMATION RECEIVED - Write the date
    I2C1_Init(100000);              // I2C and SPI are on same MCU pins
    UpdateRTC_Date(sday, smonth, syear); // Write date to RTC2 registers
    Delay_us(5);                    // Small delay required after writing via I2C
    SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV4,
                       _SPI_DATA_SAMPLE_MIDDLE,
                       _SPI_CLK_IDLE_LOW,
                       _SPI_LOW_2_HIGH);
    ClearOSD(3,5,11,25);            // Hide Menu Dialog
    MenuState = 0;
    SelectedOption = 1;
    dateOption = 0;
  break;
  }
}

void UpdateVolume(signed short val){
  unsigned short i;
  /* Regulate the volume*/
  if (val < 0){
    if(volume > 0){
      volume--;
    }
  }
  if (val > 0){
    if(volume < 50){
      volume++;
    }
  }
  /* Five different level charactes exist */
  /*
    - 0
    - 1/4
    - 1/2
    - 3/4
    - 1
  */
  for(i = 0; i < (volume/5); i++)
    MAX7456_Write(7, 10+i, 0xEE);    // 
  switch(volume%5){
    case 1:
      MAX7456_Write(7, 10+i, 0xF2);  // Add "empty" bar character
    break;
    case 2:
      MAX7456_Write(7, 10+i, 0xF1);  // Add 1/4 of "whole"
    break;                              
    case 3:                             
      MAX7456_Write(7, 10+i, 0xF0);  // Add 2/4 of "whole"
    break;                              
    case 4:                             
      MAX7456_Write(7, 10+i, 0xEF);  // Add 3/4 of "whole"
    break;
  }
  if (volume == 0)
   MAX7456_Write(7, 8, OSDchr[' ']); // Remove the Sound icon - MUTE
  else
   MAX7456_Write(7, 8, 0xFA);        // Show the Sound icon
}
/* Read the time before entering the time setup*/
void Current_Time(unsigned char *p_hours, unsigned char *p_minutes){
  I2C1_Start();                        // Issue start signal
  I2C1_Wr(RTC_ADDR);                   // Address DS1307, see DS1307 datasheet
  I2C1_Wr(1);                          // Start from address 0
  I2C1_Repeated_Start();               // Issue repeated start signal
  I2C1_Wr(RTC_ADDR + 1);               // Address DS1307 for reading R/W=1
  *p_minutes = I2C1_Rd(_I2C_ACK);      // Read minutes byte
  *p_hours = I2C1_Rd(_I2C_NACK);       // Read hours byte
  I2C1_Stop();                         // Issue stop signal
  *p_minutes  =  ((*p_minutes & 0xF0) >> 4)*10 + (*p_minutes & 0x0F);
  *p_hours    =  ((*p_hours & 0x30) >> 4)*10 + (*p_hours & 0x0F);
}
/* Read the date before entering the date setup*/
void Current_Date(unsigned char *p_day,  unsigned char *p_month, unsigned char *p_year){
  I2C1_Start();                // Issue start signal
  I2C1_Wr(RTC_ADDR);           // Address DS1307, see DS1307 datasheet
  I2C1_Wr(4);                  // Start from address 0
  I2C1_Repeated_Start();       // Issue repeated start signal
  I2C1_Wr(RTC_ADDR + 1);       // Address DS1307 for reading R/W=1

  *p_day =I2C1_Rd(_I2C_ACK);
  *p_month =I2C1_Rd(_I2C_ACK);
  *p_year =I2C1_Rd(_I2C_NACK);

  I2C1_Stop();                 // Issue stop signal
  
  *p_day = ((*p_day & 0xF0) >> 4)*10 + (*p_day & 0x0F);
  *p_month  = ((*p_month & 0x10) >> 4)*10 + (*p_month & 0x0F);
  *p_year   = ((*p_year & 0xF0)>>4)*10+(*p_year & 0x0F);
}

void MenuHidden(){             // Simple hanler function in case when menu is hidden
unsigned short i;
unsigned short j;

  if(btn == 1){               // React on RD0 - show menu
    // Print Menu Dialog
    for (i = 0; i < 8; i++ ){
      for (j = 0; j < 20; j++ ){
        if(OSmenu[i][j] != ' ')
          MAX7456_Write(i+3, j+5, OSDchr[OSmenu[i][j]]);
      }
    }
    MenuState = 1;            // Update trackong variable
  }
}

void MenuActive(){
unsigned short i;
  switch(btn){
  case 1:
    ClearOSD(3,5,11,25);      // Hide Menu Dialog
    MenuState = 0;            //
    SelectedOption = 1;       // Reset tracking variables
  break;
  case 2:                     // Change option slection
    UpdateMenu(1);
  break;
  case 3:                     // Change option slection
    UpdateMenu(-1);
  break;
  case 4:                     // Confirm slection
    switch(SelectedOption){
    case 1:                   // Enter TIME setup
      ClearOSD(4, 6, 10, 24);
      /* Set current time for time setup startup values */
      I2C1_Init(100000);
      Current_Time(&shour, &smin);
      SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV4 , 
                         _SPI_DATA_SAMPLE_MIDDLE, 
                         _SPI_CLK_IDLE_LOW, 
                         _SPI_LOW_2_HIGH);
      MAX7456_Write(8, 10, OSDchr['S']);
      MAX7456_Write(8, 11, OSDchr['E']);
      MAX7456_Write(8, 12, OSDchr['T']);
      MAX7456_Write(8, 14, OSDchr['H']);
      MAX7456_Write(8, 15, OSDchr['O']);
      MAX7456_Write(8, 16, OSDchr['U']);
      MAX7456_Write(8, 17, OSDchr['R']);
      MAX7456_Write(8, 18, OSDchr['S']);
      SetupTimeOnOSD();       // Show current time in edit time mode
      MenuState = SelectedOption + 1;
    break;
    case 2:                   // Enter DATE setup
      ClearOSD(4, 6, 10, 24);
      /* Set current date for date setup startup values */
      I2C1_Init(100000);
      Current_Date(&sday, &smonth, &syear);
      SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV4,
                         _SPI_DATA_SAMPLE_MIDDLE,
                         _SPI_CLK_IDLE_LOW,
                         _SPI_LOW_2_HIGH);
      MAX7456_Write(8, 10, OSDchr['S']);
      MAX7456_Write(8, 11, OSDchr['E']);
      MAX7456_Write(8, 12, OSDchr['T']);
      MAX7456_Write(8, 14, OSDchr['D']);
      MAX7456_Write(8, 15, OSDchr['A']);
      MAX7456_Write(8, 16, OSDchr['Y']);
      SetupDateOnOSD();
      MenuState = SelectedOption + 1;
    break;
    case 3:                   // Enter VOLUME setup
      ClearOSD(4, 6, 10, 24); //Clear Menu window
      MAX7456_Write(7, 7, 0xF9);
      MAX7456_Write(7, 8, 0xFA);
      MAX7456_Write(7, 9, 0xED);
      for(i = 0; i < 10; i++)
        MAX7456_Write(7, 10+i, 0xF2);
      MAX7456_Write(7, 20, 0xF3);
      UpdateVolume(0);
      MenuState = SelectedOption + 1;
    break;
    case 4:                   // Invert OSD
      if (!inv_flag){         // make it Black&White
        MAX7456_SPI_WRITE(0x04, 0x08);
        inv_flag = 1;
      }
      else{                   // make it White&Black
        MAX7456_SPI_WRITE(0x04, 0x00);
        inv_flag = 0;
      }
      ClearOSD(3,5,11,25);   // Hide Menu Dialog
      MenuState = 0;         // Reset
      SelectedOption = 1;    // Reset
    break;
    }
  break;
  }

}

void SetTime(){
  switch(btn){
  case 1:
    ClearOSD(3,5,11,25);  // Hide Menu Dialog
    MenuState = 0;        //
    SelectedOption = 1;   // Reset the menu tracking variables
    timeOption = 0;       //
  break;
  case 2:
    UpdateTime(1);
    SetupTimeOnOSD();
  break;
  case 3:
    UpdateTime(-1);
    SetupTimeOnOSD();
  break;
  case 4:                 // Next time setup step
     timeOption++;
     UpdateTime(0);
  break;
  }

}
void SetDate(){
  switch(btn){
  case 1:
    ClearOSD(3,5,11,25);  // Hide Menu Dialog
    MenuState = 0;
    SelectedOption = 1;
    dateOption = 0;
  break;
  case 2:
    UpdateDate(1);
    SetupDateOnOSD();
  break;
  case 3:
    UpdateDate(-1);
    SetupDateOnOSD();
  break;
  case 4:                 // Next date setup step
    dateOption++;
    UpdateDate(0);
  break;
  }

}
void SetVolume(){
  switch(btn){
  case 1:
    ClearOSD(3,5,11,25);  // Hide Menu Dialog
    MenuState = 0;
    SelectedOption = 1;
  break;
  case 2:
    UpdateVolume(1);
  break;
  case 3:
    UpdateVolume(-1);
  break;
  case 4:
    ClearOSD(3,5,11,25);  // Hide Menu Dialog
    MenuState = 0;        //
    SelectedOption = 1;   // Reset the menu tracking variables
  break;
  }
}
void BtnHandller(){
  if (MenuState != 4){
    btn = PressReleaseCheck();
  }
  else{
    btn = PressHoldCheck();
  }
  if (btn){
    switch(MenuState){    // Depending MenuState call apropriate button handler
    case 0:
      MenuHidden();
    break;
    case 1:
      MenuActive();
    break;
    case 2:
      SetTime();
    break;
    case 3:
      SetDate();
    break;
    case 4:
      SetVolume();
    break;
    }
  }
}

void BlinkEfect(){
  if (MenuState == 2){
  // Blink Time
    switch(timeOption){
    case 0:
    if (blinkF % 2){
      SetupTimeOnOSD();
    }
    else{
      MAX7456_Write(6, 12, OSDchr[' ']);
      MAX7456_Write(6, 13, OSDchr[' ']);
    }
    break;
    case 1:
    if (blinkF % 2){
      SetupTimeOnOSD();
    }
    else{
      MAX7456_Write(6, 15, OSDchr[' ']);
      MAX7456_Write(6, 16, OSDchr[' ']);
    }
    break;
    }
  }
  if (MenuState == 3){
  // Blikn Date
    switch(dateOption){
    case 0:
    if (blinkF % 2){
      SetupDateOnOSD();
    }
    else{
      MAX7456_Write(6, 8, OSDchr[' ']);
      MAX7456_Write(6, 9, OSDchr[' ']);
    }
    break;
    case 1:
    if (blinkF % 2){
      SetupDateOnOSD();
    }
    else{
      MAX7456_Write(6, 11, OSDchr[' ']);
      MAX7456_Write(6, 12, OSDchr[' ']);
    }
    break;
    case 2:
    if (blinkF % 2){
      SetupDateOnOSD();
    }
    else{
      MAX7456_Write(6, 14, OSDchr[' ']);
      MAX7456_Write(6, 15, OSDchr[' ']);
      MAX7456_Write(6, 16, OSDchr[' ']);
      MAX7456_Write(6, 17, OSDchr[' ']);
    }
    break;
    case 3:
    break;
    }
  }
  blinkC++;
  if (blinkC == 120){
    blinkF++;
    blinkC = 0;
  }
}